CREATE PROCEDURE db_drop_index
(
IN  p_indexname VARCHAR(30)
)
LANGUAGE SQL

BEGIN
DECLARE v_flag INTEGER; 
DECLARE v_sqlstmt VARCHAR(200);

DECLARE CONTINUE HANDLER FOR NOT FOUND
    BEGIN
     set v_flag =0;
    END;
   SELECT 1 into v_flag   
          FROM syscat.indexes a
         WHERE a.indname = p_indexname;
            

-- v_RowCnt := SQL%ROWCOUNT;
	IF v_flag = 1 THEN
		SET  v_sqlstmt = 'DROP INDEX ' || p_indexname;

		EXECUTE IMMEDIATE v_sqlstmt;
      
	END IF;
END
!
CALL db_drop_index('AK_AS_STATE_DTLID')
!
DROP PROCEDURE db_drop_index 
!
CREATE INDEX AK_AS_STATE_DTLID
	ON BP_AS_STATE_HDR(AS_STATE_DTLID)
	ALLOW REVERSE SCANS
!		
ALTER TABLE LG_B2BPROCESS_DTL DROP CONSTRAINT FK_LG_B2BPRC_HDR
!
DROP FUNCTION FN_Calc_CPALimits
!
DROP PROCEDURE AR_PURGE_HEADERS
!
DROP PROCEDURE LG_B2BPROCESS_DTLD
!
DROP PROCEDURE LG_B2BPROCESS_DTLI
!
DROP PROCEDURE LG_B2BPROCESS_DTLS
!
DROP PROCEDURE LG_B2BPROCESS_DTLS_ACTIVITYID
!
DROP PROCEDURE LG_B2BPROCESS_DTLS_HDRID
!
DROP PROCEDURE LG_B2BPROCESS_DTLU
!
DROP PROCEDURE LG_B2BPROCESS_HDRI_AH1
!
DROP PROCEDURE LG_B2BPROCESS_HDRS_AH2
!
DROP PROCEDURE LG_B2BPROCESS_HDRS_ACTION
!
insert into db_procauditlog (procname,startts,paramstxt) values ('LGB2BPROCESSDTLUPD',current timestamp,'Start')
!
commit
!
CREATE TABLE LG_B2BPROCESS_DTL_TAB 
(PROCESSHDRID		INTEGER			NOT NULL,
	MESSAGEID		VARCHAR(1000)	NOT NULL,
	ACTIVITYID		VARCHAR(65)		NOT NULL,
	VUID			VARCHAR(65)		NOT NULL,
	FROMPARTNERID		INTEGER,
	TOPARTNERID		INTEGER,
	TIMETOPERFORM		INTEGER,
	SERVICETYPE		VARCHAR(255),
	ACTION			VARCHAR(255),
	MSGDATETIME		TIMESTAMP,
	SEQUENCENUMBER		INTEGER,
	SYNCHRONOUSFLG		SMALLINT,
	MSGSTATUSCODE		SMALLINT,
	CONTENTTYPE		VARCHAR(255),
	ERRORCODE		VARCHAR(60),
	SEVERITY		INTEGER,
	ERRORLOCATION		VARCHAR(255),
	ERRORDESCRIPTION	VARCHAR(255),
	REFMESSAGEID		VARCHAR(1000),
	SIGNEDACK		SMALLINT,
	TIMETOLIVE		TIMESTAMP,
	FRROLE			VARCHAR(255),
	TOROLE			VARCHAR(255),
	RESPONSEURL		VARCHAR(255),
	PARENTVUID		VARCHAR(65),
	ROWTS			INTEGER		NOT NULL DEFAULT 1,
	CREATEDATE		TIMESTAMP	DEFAULT CURRENT TIMESTAMP,
	UPDATEDATE		TIMESTAMP	DEFAULT CURRENT TIMESTAMP
)
IN TS_LOG
!
CREATE TABLE temp_B2BDTL_exception LIKE LG_B2BPROCESS_DTL_TAB IN TS_LOG
!

DECLARE act_B2B_cur CURSOR FOR 
	SELECT 	PROCESSHDRID
			,MESSAGEID
			,ACTIVITYID
			,VUID
			,FROMPARTNERID
			,TOPARTNERID
			,TIMETOPERFORM
			,SERVICETYPE
			,ACTION
			,MSGDATETIME
			,SEQUENCENUMBER
			,SYNCHRONOUSFLG
			,MSGSTATUSCODE
			,CONTENTTYPE
			,ERRORCODE
			,SEVERITY
			,ERRORLOCATION
			,ERRORDESCRIPTION
			,REFMESSAGEID
			,SIGNEDACK
			,TIMETOLIVE
			,FRROLE
			,TOROLE
			,RESPONSEURL
			,PARENTVUID
			,ROWTS
			,CREATEDATE
			,UPDATEDATE
		FROM LG_B2BPROCESS_DTL
!

LOAD FROM act_B2B_cur OF CURSOR 
	INSERT INTO LG_B2BPROCESS_DTL_TAB
		(
			PROCESSHDRID
			,MESSAGEID
			,ACTIVITYID
			,VUID
			,FROMPARTNERID
			,TOPARTNERID
			,TIMETOPERFORM
			,SERVICETYPE
			,ACTION
			,MSGDATETIME
			,SEQUENCENUMBER
			,SYNCHRONOUSFLG
			,MSGSTATUSCODE
			,CONTENTTYPE
			,ERRORCODE
			,SEVERITY
			,ERRORLOCATION
			,ERRORDESCRIPTION
			,REFMESSAGEID
			,SIGNEDACK
			,TIMETOLIVE
			,FRROLE
			,TOROLE
			,RESPONSEURL
			,PARENTVUID
			,ROWTS
			,CREATEDATE
			,UPDATEDATE
	)
FOR EXCEPTION temp_B2BDTL_exception
NONRECOVERABLE
CPU_PARALLELISM 4
!
COMMIT
!
CREATE PROCEDURE LG_B2B_UPDATE
()
BEGIN
	DECLARE v_rowcnt_old BIGINT;
	DECLARE v_rowcnt_new BIGINT;
	DECLARE v_SQLText VARCHAR(255);

	SELECT count(1)
	INTO	v_rowcnt_old
	FROM	LG_B2BPROCESS_DTL;
	SELECT count(1)
	INTO	v_rowcnt_new
	FROM	LG_B2BPROCESS_DTL_TAB;
	COMMIT;	
	IF v_rowcnt_old <= v_rowcnt_new THEN
		SET v_SQLText = 'drop table temp_B2BDTL_exception';
		EXECUTE IMMEDIATE v_SQLText;
		SET v_SQLText = 'drop table LG_B2BPROCESS_DTL';
		EXECUTE IMMEDIATE v_SQLText;
		SET v_SQLText = 'rename table LG_B2BPROCESS_DTL_TAB to LG_B2BPROCESS_DTL';
		EXECUTE IMMEDIATE v_SQLText;
		COMMIT;
	END IF;
END
!
call LG_B2B_UPDATE()
!
Drop procedure LG_B2B_UPDATE
!
insert into db_procauditlog (procname,startts,paramstxt) values ('LGB2BPROCESSDTLUPD',current timestamp,'Index REbuild')
!
commit
!
ALTER TABLE LG_B2BPROCESS_DTL DATA CAPTURE NONE
!
ALTER TABLE LG_B2BPROCESS_DTL NOT VOLATILE
!
ALTER TABLE LG_B2BPROCESS_DTL APPEND ON
!
ALTER TABLE LG_B2BPROCESS_DTL LOCKSIZE ROW
!
CREATE INDEX AK_B2BPS_DTL
	ON LG_B2BPROCESS_DTL(MESSAGEID)
	ALLOW REVERSE SCANS
!
ALTER TABLE LG_B2BPROCESS_DTL
	ADD CONSTRAINT PK_B2BPS_DTL
PRIMARY KEY (ACTIVITYID, VUID)
!
--- new index for FK,purge
CREATE INDEX AK_B2BPS_DTL_1
	ON LG_B2BPROCESS_DTL(PROCESSHDRID)
	ALLOW REVERSE SCANS
!
ALTER TABLE LG_B2BPROCESS_DTL ADD CONSTRAINT FK_LG_B2BPRC_HDR 
FOREIGN KEY (PROCESSHDRID) REFERENCES LG_B2BPROCESS_HDR (PROCESSHDRID)
!

insert into db_procauditlog (procname,startts,paramstxt) values ('LGB2BPROCESSDTLUPD',current timestamp,'End')
!
