Create or Replace procedure MAS_INDEX
AS
v_indexname varchar2(100);
v_count		Integer default 0;
v_count1	Integer default 0;
v_count2	Integer default 0;
v_stmt		varchar2(1000);

BEGIN

Select count(*) into v_count from user_objects
Where object_type='INDEX' and object_name='SIB000STREAMIX';

Select count(*) into v_count1 from user_objects
Where object_type='INDEX' and object_name='SIB001STREAMIX';

Select count(*) into v_count2 from user_objects
Where object_type='INDEX' and object_name='SIB002STREAMIX';

If v_count=0 then
v_stmt:='CREATE INDEX SIB000STREAMIX ON SIB000(STREAM_ID,SEQUENCE)';
execute immediate v_stmt;
End if;

If v_count1=0 then
v_stmt:='CREATE INDEX SIB001STREAMIX ON SIB001(STREAM_ID,SEQUENCE)';
execute immediate v_stmt;
End if;

If v_count2=0 then
v_stmt:='CREATE INDEX SIB002STREAMIX ON SIB002(STREAM_ID,SEQUENCE)';
execute immediate v_stmt;
End if;

 EXCEPTION
	WHEN OTHERS THEN
		dbms_output.put_line('Create index:'||SQLERRM);
		ROLLBACK;
		RAISE_APPLICATION_ERROR (-20999, '20002 MAS_INDEX ' || SQLERRM);
End MAS_INDEX;
/
Call MAS_INDEX()
/
DROP PROCEDURE MAS_INDEX
/
