@echo off

rem * Licensed Materials - Property of IBM
rem * 5724-L68, 5724-L69
rem * (C) Copyright IBM Corp. 2007 - All Rights Reserved.
rem * US Government Users Restricted Rights - Use, duplication or disclosure
rem * restricted by GSA ADP Schedule Contract with IBM Corp.

setlocal ENABLEDELAYEDEXPANSION

rem * Verify input params count, should not be less than 5 and give usage
if %5x == x goto USAGE

rem *  Initialise the variables
set package=packagename
set packageversion=packagever
set protocol=protocolname
set protocolversion=protocolver
set process=processname
set processversion=processver

set userid=%1
shift
set password=%1
shift
set cutoffdate=%1

rem * Convert input date format of YYYYMMDD to DB2 format of YYYY-MM-DD and do the validations as well

if %cutoffdate% lss 20000101 goto DATEERROR

set cutoffdateyy=%cutoffdate:~0,4%
if %cutoffdateyy% lss 2000 goto DATEERROR

set cutoffdatemm=%cutoffdate:~4,2%
if %cutoffdatemm:~0,1% EQU 0 set cutoffdatemm=%cutoffdatemm:~1%
if %cutoffdatemm% lss 1 goto DATEERROR
if %cutoffdatemm% gtr 12 goto DATEERROR

set cutoffdatedd=%cutoffdate:~6,2%
if %cutoffdatedd:~0,1% EQU 0 set cutoffdatedd=%cutoffdatedd:~1%
if %cutoffdatedd% lss 1 goto DATEERROR
if %cutoffdatedd% gtr 31 goto DATEERROR

set cutoffdateuse=%cutoffdateyy%-%cutoffdatemm%-%cutoffdatedd%

shift
set archivedest=%1
shift
set partner=%1

rem * Take and Manipulate optional input parameters. If the input parm is * then set it to column name
rem * for easier SQL otherwise put quotes around it.


if %partner%==* (
	set partner=partnername
	) else (
	set partner='%partner%'
	)
shift
if not %1x==x (
		set package=%1
		if !package!==* (
					set package=packagename
					) else (
					set package='!package!'
					)
			)
shift
if not %1x==x (
		set packageversion=%1
		if !packageversion!==* (
					set packageversion=packagever
					) else (
					set packageversion='!packageversion!'
					)
			)
shift			
if not %1x==x (
		set protocol=%1
		if !protocol!==* (
					set protocol=protocolname
					) else (
					set protocol='!protocol!'
					)
			)
shift			
if not %1x==x (
		set protocolversion=%1
		if !protocolversion!==* (
					set protocolversion=protocolver
					) else (
					set protocolversion='!protocolversion!'
					)
			)
shift			
if not %1x==x (
		set process=%1
		if !process!==* (
					set process=processname
					) else (
					set process='!process!'
					)
			)
shift			
if not %1x==x (
		set processversion=%1
		if !processversion!==* (
					set processversion=processver
					) else (
					set processversion='!processversion!'
					)
			)
rem * Verify input params count, should not be more than 11 and give usage
shift
if not %1x == x goto USAGE
			

IF NOT EXIST %archivedest%\%cutoffdate% mkdir  %archivedest%\%cutoffdate%

@echo Trying to connect to the database. Please Wait ...
db2 connect to $DB_NAME$ user %userid% using %password%
if %ERRORLEVEL% gtr 0 goto USAGE
@echo Connected to database and Export in Progress. Please Wait ...
rem * db2 "export to %archivedest%\%cutoffdate%\bcgDBNonRepExport.ixf of ixf messages %archivedest%\%cutoffdate%\bcgDBNonRepExport.txt lobs to  %2\%1 lobfile lobs1, lobs2 modified by lobsinfile select * from lg_msg_archive where createdate < timestamp('%cutoffdateuse%-00.00.00.000000') and partnername = %partner% and packagename= %package% and packagever= %packageversion% and protocolname = %protocol% and protocolver = %protocolversion% and processname= %process% and processver = %processversion% "
rem * db2 "export to %archivedest%\%cutoffdate%\bcgDBNonRepExport.del of del lobs to %archivedest%\%cutoffdate% lobfile lobs1, lobs2 modified by lobsinfile select * from lg_msg_archive where createdate < timestamp('%cutoffdateuse%-00.00.00.000000') and partnername = %partner% and packagename= %package% and packagever= %packageversion% and protocolname = %protocol% and protocolver = %protocolversion% and processname= %process% and processver = %processversion% "
db2 "export to %archivedest%\%cutoffdate%\bcgDBNonRepExport.ixf of ixf lobs to  %archivedest%\%cutoffdate% lobfile lobs1, lobs2 modified by lobsinfile select * from lg_msg_archive where createdate < timestamp('%cutoffdateuse%-00.00.00.000000') and partnername = %partner% and packagename= %package% and packagever= %packageversion% and protocolname = %protocol% and protocolver = %protocolversion% and processname= %process% and processver = %processversion% "

if %ERRORLEVEL% gtr 0 ( 
			echo The Non Rep Export failed to run
			goto USAGE
		      ) else (
		        echo The Non Rep Export program ran successfully
		             )

rem * db2 "export to %2\%1\certarchive.del of del lobs to %2\%1 lobfile lobs1, lobs2 modified by lobsinfile select * from lg_cert_archive where createdate < timestamp('%1-00.00.00.000000')"

db2 +o connect reset

goto endofprog

:USAGE
@echo 
@echo The script needs the following parameters
@echo 1. Database user name
@echo 2. Database user password
@echo 3. Cutoff date YYYYMMDD
@echo 4. Destination for the archive
@echo 5. Partner Name
@echo 6. Package Name
@echo 7. Package Version
@echo 8. Protocol Name
@echo 9. Protocol Version
@echo 10. Process Name
@echo 11. Process Version

@echo "USAGE  : bcgDBNonRepExport <userid> <password> <cutoff date YYYYMMDD> <archive destination> <partner> [package] [package version] [protocol] [protocol version] [process] [process version]"

@echo "SAMPLE : bcgDBNonRepExport db2admin pa55word 20050318 C:\Temp\Database  partnerA  N/A * None * EDI-X12 * "
goto endofprog
:DATEERROR
@echo The input date format is not right. It should be YYYYMMDD
goto USAGE
:endofprog