@echo off

rem * Licensed Materials - Property of IBM
rem * 5724-L68, 5724-L69
rem * (C) Copyright IBM Corp. 2007 - All Rights Reserved.
rem * US Government Users Restricted Rights - Use, duplication or disclosure
rem * restricted by GSA ADP Schedule Contract with IBM Corp.

setlocal ENABLEDELAYEDEXPANSION

rem * Verify input params count, should not be less than 5 and give usage
if %5x == x goto USAGE

rem *  Initialise the variables
set package=packagename
set packageversion=packagever
set protocol=protocolname
set protocolversion=protocolver
set process=processname
set processversion=processver

set userid=%1
shift
set password=%1
shift
set cutoffdate=%1

rem * Validate the input date
if %cutoffdate% lss 20000101 goto DATEERROR

set cutoffdateyy=%cutoffdate:~0,4%
if %cutoffdateyy% lss 2000 goto DATEERROR

set cutoffdatemm=%cutoffdate:~4,2%
if %cutoffdatemm:~0,1% EQU 0 set cutoffdatemm=%cutoffdatemm:~1%
if %cutoffdatemm% lss 1 goto DATEERROR
if %cutoffdatemm% gtr 12 goto DATEERROR

set cutoffdatedd=%cutoffdate:~6,2%
if %cutoffdatedd:~0,1% EQU 0 set cutoffdatedd=%cutoffdatedd:~1%
if %cutoffdatedd% lss 1 goto DATEERROR
if %cutoffdatedd% gtr 31 goto DATEERROR

shift
set archivedest=%1
shift
set partner=%1

rem * Take and Manipulate optional input parameters. If the input parm is * then set it to column name
rem * for easier SQL otherwise put quotes around it.


if %partner%==* (
	set partner=partnername
	) else (
	set partner='%partner%'
	)
shift
if not %1x==x (
		set package=%1
		if !package!==* (
					set package=packagename
					) else (
					set package='!package!'
					)
			)
shift
if not %1x==x (
		set packageversion=%1
		if !packageversion!==* (
					set packageversion=packagever
					) else (
					set packageversion='!packageversion!'
					)
			)
shift			
if not %1x==x (
		set protocol=%1
		if !protocol!==* (
					set protocol=protocolname
					) else (
					set protocol='!protocol!'
					)
			)
shift			
if not %1x==x (
		set protocolversion=%1
		if !protocolversion!==* (
					set protocolversion=protocolver
					) else (
					set protocolversion='!protocolversion!'
					)
			)
shift			
if not %1x==x (
		set process=%1
		if !process!==* (
					set process=processname
					) else (
					set process='!process!'
					)
			)
shift			
if not %1x==x (
		set processversion=%1
		if !processversion!==* (
					set processversion=processver
					) else (
					set processversion='!processversion!'
					)
			)
rem * Verify input params count, should not be more than 11 and give usage
shift
if not %1x == x goto USAGE
			
IF NOT EXIST %archivedest%\%cutoffdate% mkdir  %archivedest%\%cutoffdate%


exp SYSTEM/%password%@$DB_NAME$ FILE=%archivedest%/%cutoffdate%/bcgDBNonRepExport.dmp  TABLES=(%userid%.LG_MSG_ARCHIVE) QUERY=\"WHERE CREATEDATE <TO_DATE('%cutoffdate%','YYYYMMDD') and partnername = %partner% and packagename= %package% and packagever= %packageversion% and protocolname = %protocol% and protocolver = %protocolversion% and processname= %process% and processver = %processversion% \" LOG=%archivedest%/%cutoffdate%/bcgDBNonRepExport.log STATISTICS=NONE

if %ERRORLEVEL% gtr 0 ( 
			echo The Non Rep Export failed to run
			goto USAGE
		      ) else (
		     		        echo The Non Rep Export program ran successfully
		             )
goto endofprog

:USAGE
@echo The script needs the following parameters
@echo 1. Database user name
@echo 2. SYSTEM user password
@echo 3. Cutoff date YYYYMMDD
@echo 4. Destination for the archive
@echo 5. Partner Name
@echo 6. Package Name
@echo 7. Package Version
@echo 8. Protocol Name
@echo 9. Protocol Version
@echo 10. Process Name
@echo 11. Process Version

@echo "USAGE  : bcgDBNonRepExport <userid> <SYSTEM password> <cutoff date YYYYMMDD> <archive destination> <partner> [package] [package version] [protocol] [protocol version] [process] [process version]"

@echo "SAMPLE : bcgDBNonRepExport bcgapps pa55word 20050318 C:\Temp\Database  partnerA  N/A * None * EDI-X12 * "
goto endofprog
:DATEERROR
@echo The input date format is not right. It should be YYYYMMDD
goto USAGE
:endofprog