@echo off

rem * Licensed Materials - Property of IBM
rem * 5724-L68, 5724-L69
rem * (C) Copyright IBM Corp. 2007 - All Rights Reserved.
rem * US Government Users Restricted Rights - Use, duplication or disclosure
rem * restricted by GSA ADP Schedule Contract with IBM Corp.
setlocal ENABLEDELAYEDEXPANSION

set package=allO0oxyz
set packageversion=allO0oxyz
set protocol=allO0oxyz
set protocolversion=allO0oxyz
set process=allO0oxyz
set processversion=allO0oxyz


If %1X == X  goto Usage
set userid=%1
shift
If %1X == X  goto Usage
set password=%1
shift
If %1X == X  goto Usage
set cutoffdate=%1


rem * Do the date validation
if %cutoffdate% lss 20000101 goto DATEERROR

set cutoffdateyy=%cutoffdate:~0,4%
if %cutoffdateyy% lss 2000 goto DATEERROR

set cutoffdatemm=%cutoffdate:~4,2%
if %cutoffdatemm:~0,1% EQU 0 set cutoffdatemm=%cutoffdatemm:~1%
if %cutoffdatemm% lss 1 goto DATEERROR
if %cutoffdatemm% gtr 12 goto DATEERROR

set cutoffdatedd=%cutoffdate:~6,2%
if %cutoffdatedd:~0,1% EQU 0 set cutoffdatedd=%cutoffdatedd:~1%
if %cutoffdatedd% lss 1 goto DATEERROR
if %cutoffdatedd% gtr 31 goto DATEERROR

set cutoffdateuse=%cutoffdateyy%-%cutoffdatemm%-%cutoffdatedd%

shift
If %1X == X  goto Usage   
   SET partner=%1
if %partner%==* (
	set partner=allO0oxyz
	) 
	
shift
if not %1x==x (
		set package=%1
		if !package!==* (
					set package=allO0oxyz
					) 
			)
shift
if not %1x==x (
		set packageversion=%1
		if !packageversion!==* (
					set packageversion=allO0oxyz
										)
			)
shift			
if not %1x==x (
		set protocol=%1
		if !protocol!==* (
					set protocol=allO0oxyz
					)
			)
shift			
if not %1x==x (
		set protocolversion=%1
		if !protocolversion!==* (
					set protocolversion=allO0oxyz
					)
			)
shift			
if not %1x==x (
		set process=%1
		if !process!==* (
					set process=allO0oxyz
					)
			)
shift			
if not %1x==x (
		set processversion=%1
		if !processversion!==* (
					set processversion=allO0oxyz
					)
			)
rem * Verify input params count, should not be more than 10 and give usage
shift
if not %1x==x goto USAGE

set sqlfile=%TEMP%\execsummarysql.sql

call del /F /Q %sqlfile% 2>NUL
echo set feedback off >>%sqlfile%

echo execute AR_NONREP_MAINTENANCE('%cutoffdateuse%','%partner%', '%package%', '%packageversion%', '%protocol%', '%protocolversion%', '%process%', '%processversion%','%userid%') >> %sqlfile%
echo set feedback on >>%sqlfile%
ECHO exit >>%sqlfile%

call sqlplus -L -S %userid%/%password%@$DB_NAME$ @%sqlfile%
if %ERRORLEVEL% gtr 0 ( 
			echo The NonRep Maintenance procedure failed to run
			goto USAGE
		      ) else (        
		        echo The NonRep Maintenance program ran successfully
		             )
call del /F /Q %sqlfile% 2>NUL

goto endofprog
:USAGE
@echo 
@echo The script needs the following parameters
@echo 1. Database user name
@echo 2. Database user password
@echo 3. Cutoff date YYYYMMDD
@echo 4. Partner Name
@echo 5. Package Name
@echo 6. Package Version
@echo 7. Protocol Name
@echo 8. Protocol Version
@echo 9. Process Name
@echo 10. Process Version


@echo "USAGE  : bcgNonRepMaintenance <userid> <password> <cutoff date YYYYMMDD> <partner> [package] [package version] [protocol] [protocol version] [process] [process version]"

@echo "SAMPLE : bcgNonRepMaintenance db2admin pa55word 20050318 partnerA  N/A * None * EDI-X12 * "
goto endofprog
:DATEERROR
@echo The input date format is not right. It should be YYYYMMDD
goto USAGE
:endofprog