@echo off

rem * Licensed Materials - Property of IBM
rem * 5724-L68, 5724-L69
rem * (C) Copyright IBM Corp. 2007 - All Rights Reserved.
rem * US Government Users Restricted Rights - Use, duplication or disclosure
rem * restricted by GSA ADP Schedule Contract with IBM Corp.
if %3x == x goto USAGE

set userid=%1
shift
set password=%1
shift
set cutoffdate=%1

rem * Convert input date format of YYYYMMDD to DB2 format of YYYY-MM-DD and do the validations as well
if %cutoffdate% lss 20000101 goto DATEERROR

set cutoffdateyy=%cutoffdate:~0,4%
if %cutoffdateyy% lss 2000 goto DATEERROR

set cutoffdatemm=%cutoffdate:~4,2%
if %cutoffdatemm:~0,1% EQU 0 set cutoffdatemm=%cutoffdatemm:~1%
if %cutoffdatemm% lss 1 goto DATEERROR
if %cutoffdatemm% gtr 12 goto DATEERROR

set cutoffdatedd=%cutoffdate:~6,2%
if %cutoffdatedd:~0,1% EQU 0 set cutoffdatedd=%cutoffdatedd:~1%
if %cutoffdatedd% lss 1 goto DATEERROR
if %cutoffdatedd% gtr 31 goto DATEERROR

set cutoffdateuse=%cutoffdateyy%-%cutoffdatemm%-%cutoffdatedd%
set sqlfile=%TEMP%\execsummarysql.sql

call del /F /Q %sqlfile% 2>NUL
echo set feedback off >>%sqlfile%

echo execute AR_SUMMARY_MAINTENANCE('%cutoffdateuse%') >> %sqlfile%
echo insert into lg_archiveinfo(archiveid, actionname, cutoffdate) values(LG_ARCHIVEINFO_SEQ.nextval,'SUMMARY ENGINE PURGE',to_date('%cutoffdate%','YYYYMMDD')); >> %sqlfile%
echo set feedback on >>%sqlfile%
ECHO exit >>%sqlfile%

call sqlplus -L -S %userid%/%password%@$DB_NAME$ @%sqlfile%
if %ERRORLEVEL% gtr 0 ( 
			echo The purge procedure failed to run
			goto USAGE
		      ) else (        
		        echo The Summary Purge program ran successfully
		             )
call del /F /Q %sqlfile% 2>NUL

goto endofprog
:USAGE
@echo 
@echo The script needs the following parameters
@echo 1. Database user name
@echo 2. Database user password
@echo 3. Cutoff date YYYYMMDD

@echo "USAGE  : bcgSummaryMaintenance <userid> <password> <cutoff date YYYYMMDD>"

@echo "SAMPLE : bcgSummaryMaintenance db2admin pa55word 20050318 "
goto endofprog
:DATEERROR
@echo The input date format is not right. It should be YYYYMMDD
goto USAGE
:endofprog