@echo off

rem * Licensed Materials - Property of IBM
rem * 5724-L68,5724-L69
rem * (C) Copyright IBM Corp. 2006 - All Rights Reserved.
rem * US Government Users Restricted Rights - Use, duplication or disclosure
rem * restricted by GSA ADP Schedule Contract with IBM Corp.

setlocal ENABLEDELAYEDEXPANSION

rem These values (enclosed in $) will be replaced by the install wizard
set BCGHUB_HOME=$BCGHUB_HOME$

call "%BCGHUB_HOME%\bin\bcgSetupCmdLine.bat"

SET DB_HOSTNAME=$DB_HOSTNAME$
SET DB_PORT=$DB_PORT$
SET DB_NAME=$DB_NAME$
SET DB_SCHEMA=$DB_SCHEMA$
SET DBTYPE=$DB_TYPE$
SET JDBC_DRIVER=$JDBC_DRIVER$
SET LOGGER_FILE=%BCGHUB_HOME%\_jvm\jre\lib\logging.properties


set package=allO0oxyz
set packageversion=allO0oxyz
set protocol=allO0oxyz
set protocolversion=allO0oxyz
set process=allO0oxyz
set processversion=allO0oxyz


SET APP_LIB=%BCGHUB_HOME%\lib\db2jcc.jar;%BCGHUB_HOME%\lib\db2jcc_license_cu.jar;%JDBC_DRIVER%

SET  APP_CLASSPATH=%APP_LIB%;%BCGHUB_HOME%\bin\BcgArchive.jar;
SET CLASSPATH=%APP_CLASSPATH%;%CLASSPATH%

SET PATH=%PATH%;%JAVA_HOME%\bin

IF NOT %DBTYPE%==ORACLE goto NotOracle
   SET JDBC_DRIVER_CLASS=oracle.jdbc.OracleDriver
   SET JDBC_URL=jdbc:oracle:thin:@%DB_HOSTNAME%:%DB_PORT%:%DB_NAME%
   goto EndDBTypeCheck
:NotOracle
REM  Default to DB2
   SET JDBC_DRIVER_CLASS=com.ibm.db2.jcc.DB2Driver
   SET JDBC_URL=jdbc:db2://%DB_HOSTNAME%:%DB_PORT%/%DB_NAME%
   goto EndDBTypeCheck   
:EndDBTypeCheck

REM Input args
If %1X == X  goto Usage
   SET USERID=%1
   shift   
If %1X == X  goto Usage   
   SET PASSWORD=%1
   shift
If %1X == X  goto Usage   
   SET CUTOFFDATE=%1
   shift
rem * Do the date validations
call :EVALDATE
if %cutoffdateuse%X EQU X goto endofprog

If %1X == X  goto Usage
   SET ARCHIVETASK=%1
   shift
rem * add validation for copy and delete
If %1X == X  goto Usage   
   SET MODULE=%1
   shift

If %1X == X  goto Usage   
   SET DESTINATION=%1
   shift
If %1X == X  goto Usage   
   SET partner=%1
if %partner%==* (
	set partner=allO0oxyz
	) 
	
shift
if not %1x==x (
	set package=%1
	if !package!==* (
		set package=allO0oxyz
	) 
)
shift
if not %1x==x (
	set packageversion=%1
	if !packageversion!==* (
		set packageversion=allO0oxyz
	) 
)
shift			
if not %1x==x (
	set protocol=%1
	if !protocol!==* (
		set protocol=allO0oxyz
	) 
)
shift			
if not %1x==x (
	set protocolversion=%1
	if !protocolversion!==* (
		set protocolversion=allO0oxyz
	) 
)
shift			
if not %1x==x (
	set process=%1
	if !process!==* (
		set process=allO0oxyz
	) 
)
shift			
if not %1x==x (
	set processversion=%1
	if !processversion!==* (
		set processversion=allO0oxyz
	) 
)
rem * Verify input params count, should not be more than 13 and give usage
shift
if not %1x==x goto USAGE

rem * add validation for ARCHIVETASK AND MODULE: NONREP|MSGSTORE|COMMON|PURGEDATA
   
echo %MODULE% | find "PURGEDATA" > NUL
if NOT ERRORLEVEL 1 (
	echo %MODULE% | find "NONREP" | find "MSGSTORE" | find "COMMON" >NUL
	if ERRORLEVEL 1 (
		echo Invalid PURGEDATA option.
		echo PURGEDATA should be used with DELETE task and module "NONREP|MSGSTORE|COMMON|PURGEDATA"
		GOTO usage
	)
	echo %ARCHIVETASK% | find "DELETE" >NUL
	if ERRORLEVEL 1 (
		echo Invalid PURGEDATA option.
		echo PURGEDATA should be used with DELETE task and module "NONREP|MSGSTORE|COMMON|PURGEDATA"
		GOTO usage
	)
) else (
rem * RESET the errorlevel
	DIR >NUL
)

echo
echo JDBC_URL = %JDBC_URL% 
echo JDBC_DRIVER_CLASS = %JDBC_DRIVER_CLASS%
echo JDBC_QUAL = %JDBC_QUAL% 
echo USERID = %USERID% 
echo CUTOFFDATE = %CUTOFFDATE%
echo JAVA_HOME = %JAVA_HOME%
echo


"%JAVA_HOME%\bin\java"  -cp .;%JDBC_DRIVER%;"%CLASSPATH%" com.ibm.bcg.db.util.DBArchiveMgmt %JDBC_URL% %JDBC_DRIVER_CLASS%  %USERID% %PASSWORD% %CUTOFFDATEUSE% %ARCHIVETASK% %MODULE% %DESTINATION% %DBTYPE% %PARTNER% %PACKAGE% %PACKAGEVERSION% %PROTOCOL% %PROTOCOLVERSION% %PROCESS% %PROCESSVERSION% %LOGGER_FILE% %DB_SCHEMA%

IF  %errorlevel%==0 goto endofprog

:EVALDATE
:: Convert input date format of YYYYMMDD to DB2 format of YYYY-MM-DD and do the validations as well
:: initialize
set cutoffdateuse=
if %cutoffdate% LSS 20000101 goto DATEERROR

set cutoffdateyy=%cutoffdate:~0,4%
if %cutoffdateyy% LSS 2000 goto DATEERROR

set cutoffdatemm=%cutoffdate:~4,2%
:: change to decimal by stripping leading 0 (01 to 07 are octal numbers, 08 and 09 are not recognized)
if %cutoffdatemm:~0,1% EQU 0 set cutoffdatemm=%cutoffdatemm:~1%
if %cutoffdatemm% LSS 1 goto DATEERROR
if %cutoffdatemm% GTR 12 goto DATEERROR

set cutoffdatedd=%cutoffdate:~6,2%
if %cutoffdatedd:~0,1% EQU 0 set cutoffdatedd=%cutoffdatedd:~1%
if %cutoffdatedd% LSS 1 goto DATEERROR

:: leap year is multiple of 4, not of 100 except of 400
set /a div004=(%cutoffdateyy% %% 4)
set /a div100=(%cutoffdateyy% %% 100)
set /a div400=(%cutoffdateyy% %% 400)
if %div004% EQU 0 (
	set leap=1
	if %div100% EQU 0 (
		set leap=0
		if %div400% EQU 0 set leap=1
	)
) else set leap=0
	
if %leap% EQU 0 (
	set MonthTable=31 28 31 30 31 30 31 31 30 31 30 31
) else (
	set MonthTable=31 29 31 30 31 30 31 31 30 31 30 31
)

set /a monthindex=%cutoffdatemm% * 3 - 3
set daysinmonth=!MonthTable:~%monthindex%,3%!
if %cutoffdatedd% GTR %daysinmonth% goto DATEERROR

set datetst=%cutoffdatemm%X
if "%datetst:~1,1%" EQU "X" set cutoffdatemm=0%cutoffdatemm%
set datetst=%cutoffdatedd%X
if "%datetst:~1,1%" EQU "X" set cutoffdatedd=0%cutoffdatedd%

set cutoffdateuse=%cutoffdateyy%-%cutoffdatemm%-%cutoffdatedd%
set cutoffdate=%cutoffdateyy%%cutoffdatemm%%cutoffdatedd%
goto endofprog

:USAGE
@echo 
@echo The script needs the following parameters
@echo 1. Database user name
@echo 2. Database user password
@echo 3. Cutoff date YYYYMMDD
@echo 4. Archive Task : COPY or DELETE
@echo 5. Module: NONREP or MSGSTORE or COMMON or "NONREP|MSGSTORE|COMMON|PURGEDATA"
@echo 6. Destination for the archive
@echo 7. Partner Name
@echo 8. Package Name
@echo 9. Package Version
@echo 10. Protocol Name
@echo 11. Protocol Version
@echo 12. Process Name
@echo 13. Process Version

@echo "USAGE  : bcgArchive <userid> <password> <cutoff date YYYYMMDD> <archive task: COPY|DELETE> <module: NONREP|MSGSTORE|COMMON|PURGEDATA> <archive destination> <partner> [package] [package version] [protocol] [protocol version] [process] [process version]"

@echo "SAMPLE : bcgArchive db2admin pa55word 20050318 COPY NONREP C:\Temp\Database\20050318\  partnerA  N/A * None * EDI-X12 * "
goto endofprog
:DATEERROR
@echo The input date format is not right. It should be YYYYMMDD. 
goto USAGE
:endofprog
@endlocal
